(function(window){
//对Date的扩展，将 Date 转化为指定格式的String   
//月(M)、日(d)、小时(h)、分(m)、秒(s)、季度(q) 可以用 1-2 个占位符，   
//年(y)可以用 1-4 个占位符，毫秒(S)只能用 1 个占位符(是 1-3 位的数字)   
//例子：   
//(new Date()).Format("yyyy-MM-dd hh:mm:ss.S") ==> 2006-07-02 08:09:04.423   
//(new Date()).Format("yyyy-M-d h:m:s.S")      ==> 2006-7-2 8:9:4.18   
Date.prototype.Format = function(fmt){
	if(this.getDate()>0){
		  var o = {   
		    "M+" : this.getMonth()+1,                 //月份   
		    "d+" : this.getDate(),                    //日   
		    "h+" : this.getHours(),                   //小时   
		    "m+" : this.getMinutes(),                 //分   
		    "s+" : this.getSeconds(),                 //秒   
		    "q+" : Math.floor((this.getMonth()+3)/3), //季度   
		    "S"  : this.getMilliseconds()             //毫秒   
		  };   
		  if(/(y+)/.test(fmt))   
		    fmt=fmt.replace(RegExp.$1, (this.getFullYear()+"").substr(4 - RegExp.$1.length));   
		  for(var k in o)   
		    if(new RegExp("("+ k +")").test(fmt))   
		  	fmt = fmt.replace(RegExp.$1, (RegExp.$1.length==1) ? (o[k]) : (("00"+ o[k]).substr((""+ o[k]).length)));   
		  	return fmt;   
	}else{
		return '';
	}
};
function getTimestamp () {
	return new Date().getTime();	
}
	var index = 0;
	var u = {};
	var http_client = "http://app.ieguanjia.com";
//	var http_client = "http://192.168.1.16:8080/property-app";
	var imgUrl = "";
	
	var ajaxSettings = {
		uri : "/mvc/index",
		method : "post",
		data: "",
		headers :{},
		cache :false,
		showLoading : false,
		onSuccess : function () {
		},
		onError : function () {
		}
	}
	
	u.http_client = http_client;
	u.imgUrl = imgUrl;
	var url = localStorage.getItem("imgUrl");
	if(url != undefined && url != null){
		u.imgUrl = url;
	}
	u.ajaxClient = function  (options) {//ajax请求 无需验证身份
		var settings = $.extend({}, options || {});
			for (key in ajaxSettings) if (settings[key] === undefined) settings[key] = ajaxSettings[key]
			if (settings.showLoading) {
				api.showProgress({
			    	title: '努力加载中...',
			   		modal: false
				});
			}
			api.ajax({
			    url: http_client + settings.uri,
			    method: settings.method,
			    cache :true,
			    data: {
			        values: settings.data,
			        files: {
			        	"pic" : 'a.gif'
			        }
			    }
			}, function(ret, err) {
				if (settings.showLoading) {
					api.hideProgress();
				}
			    if (ret) {
			      settings.onSuccess(ret);
			    } else {
			    	if (err.statusCode == 0) {
			    		api.refreshHeaderLoadDone();
			    		api.toast({
						    msg: '网络错误，请重试',
						    duration: 2000,
						    location: 'bottom'
						});
			    		return;
			    	}
			       settings.onError(err);
			    }
			});
	}
	
	u.ajaxTokenClient = function  (options) {
		var settings = $.extend({}, options || {});
			for (key in ajaxSettings) if (settings[key] === undefined) settings[key] = ajaxSettings[key]
			var tokenparam = getTimestamp() + api.deviceId;
			var skey = tokenparam.substring(0,16);
			var token = '';
			token = api.getPrefs({
			    sync: true,
			    key: 'token'
			});	
			
			var encryptData = est.Encrypt(JSON.stringify(settings.data),token.substring(0,16));//使用token加密参数 该算法密钥长度需为16的倍数 这里截取0-16位
			token = est.Encrypt(token,skey) //加密token
			if (settings.showLoading) {
				api.showProgress({
			    	title: '努力加载中...',
			   		modal: false
				});
			}
			var a = '';
			if (settings.uri.indexOf('?')>-1) {
				a = '&data=';
			}else{
				a = '?data=';
			}
			api.ajax({
			    url: http_client + settings.uri + a + encryptData,
			    method: settings.method,
			    headers : {tokenparam:tokenparam,token:token},
			    dataType : "text",
			    data: {
			        values: {
			           // data: encryptData
			        },
			        files: settings.filepath
			    }
			}, function(ret, err) {
				index++;
				if (settings.showLoading) {
					api.hideProgress();
				}
			    if (ret) {
			    	var token = api.getPrefs({
					    sync: true,
					    key: 'token'
					});
					var result = est.Decrypt(ret,token.substring(0,16))
					var str = eval('('+result+')');
			      	settings.onSuccess(str);
			    } else {
			    	api.refreshHeaderLoadDone();
			    	if (err.statusCode == 0) {
			    		api.refreshHeaderLoadDone();
			    		api.toast({
						    msg: '网络错误，请重试',
						    duration: 2000,
						    location: 'bottom'
						});
			    		return;
			    	}
			    	if (err.statusCode == 403) {
			    		api.refreshHeaderLoadDone();
			    		alert("请求出错，请重试")
			    		return;
			    	}
			    	if(status == 505){
						if(index == 1){
							alert("当前版本为免费版,先前往PC升级为收费版");
							setTimeout(function  () {
								index = 0
							},2000)
						}
					}
					if(status == 406){
						if(index == 1){
							myApp.alert("当前版本已到期,请前往PC进行续费或前往PC切换收费版本的公司","提示");
							setTimeout(function  () {
								index = 0
							},2000)
						}
					}
			       settings.onError(err);
			    }
			});
	}
	
	u.token = function  (opt) { //登录
		var tokenparam = getTimestamp() + api.deviceId;
			var skey = tokenparam.substring(0,16);
			var encryptData = est.Encrypt(JSON.stringify(opt.data),skey);//aes加密传递的数据,在服务端解密
			api.showProgress({
			    title: '努力加载中...',
			    modal: false
			});
			api.ajax({
			    url: http_client + "/token",
			    method: "post",
			    headers :{tokenparam:tokenparam},
			    dataType : "text",
			   data: {
			        values: {
			            data: encryptData
			        },
			        files: {
			            file: 'fs://a.gif'
			        }
			    },
			}, function(ret, err) {
				var result = JSON.parse(est.Decrypt(ret,skey))
				api.hideProgress();
				opt.onSuccess(result)
			});
	}
	
	u.hasLogin = function () {
		//判断是否登录
		var token = api.getPrefs({
		    sync: true,
		    key: 'wxToken'
		});
		if (token == "") {
			return false;
		}else{
			return true;
		}
	}
	
	u.Encrypt = function  (word,skey) {
		//aes加密
		var key = CryptoJS.enc.Utf8.parse(skey);   
        var srcs = CryptoJS.enc.Utf8.parse(word);  
        var encrypted = CryptoJS.AES.encrypt(srcs, key, {mode:CryptoJS.mode.ECB,padding: CryptoJS.pad.Pkcs7});  
        return encrypted.toString();  
	}
	
	u.Decrypt = function  (word,skey) {
		//aes解密
		var key = CryptoJS.enc.Utf8.parse(skey);
		var decrypt = CryptoJS.AES.decrypt(word, key, {mode:CryptoJS.mode.ECB,padding: CryptoJS.pad.Pkcs7});  
    	return CryptoJS.enc.Utf8.stringify(decrypt).toString();  
	}
	
	u.openlogin = function  (opt) {//沒有登录跳转登录
		setTimeout(function  () {
			api.openWin({
	        name: 'login',
	        url: '../login.html',
	        delay : u.delay(),
	         pageParam: opt,
	   	 });
		},500)
	}
	u.fixIos7Bar = function(el){
        var strDM = api.systemType;
        if (strDM == 'ios') {
            var strSV = api.systemVersion;
            var numSV = parseInt(strSV,10);
            var fullScreen = api.fullScreen;
            var iOS7StatusBarAppearance = api.iOS7StatusBarAppearance;
            if (numSV >= 7 && !fullScreen && iOS7StatusBarAppearance) {
                el.style.paddingTop = '20px';
            }
        }
    };
	u.fixStatusBar = function  (el) {
        var sysType = api.systemType;
        if(sysType == 'ios'){
            u.fixIos7Bar(el);
        }else if(sysType == 'android'){
            var ver = api.systemVersion;
            ver = parseFloat(ver);
            if(ver >= 4.4){
                el.style.paddingTop = '25px';
            }
        }
	}
	
	u.back = function  () {
		api.closeWin();
	}
	
	u.delay = function  () {
		if (api.systemType == "ios") {
		 	 return 0
		 }else{
		 	 return 150
		 }
	}
	
	u.jsonDateFormat = function(obj,format) {
		if(obj!=null){
		var date = new Date();
		date.setTime(obj.time);
		date.setHours(obj.hours);
		date.setMinutes(obj.minutes);
		date.setSeconds(obj.seconds);
		return date.Format(format); 
		}else{
			return null;
		}
	}
	
	 window.est = u;
})(window);
